using System;
using System.Collections.Generic;
using Upsilon.BoundTypes;

namespace Upsilon.BaseTypes.UserData
{
    public static class UserDataTypeHandler
    {
        private static readonly Dictionary<System.Type, UserDataType> Types = new Dictionary<System.Type, UserDataType>();

        public static void LoadType(System.Type t)
        {
            var info = new UserDataType(t);
            Types.Add(t, info);
            UserDataBoundTypeDefinition boundType;
            if (t.IsEnum)
            {
                boundType = new UserDataBoundEnumDefinition(t);
            }
            else
            {
                boundType = UserDataBoundTypeDefinition.Create(t);
            }
            BoundTypeHandler.LoadUserDataTypeDefinition(boundType);
        }

        public static void LoadType<T>()
        {
            LoadType(typeof(T));
        }

        internal static UserDataType GetTypeInfo(System.Type t)
        {
            return Types[t];
        }
    }
}