using System.Collections.Generic;
using Upsilon.Text;

namespace Upsilon.Binder
{
    public class BoundScript : BoundStatement
    {
        public BoundScript(BoundBlockStatement statement, TextSpan span, BoundScope scope) : base(span)
        {
            Statement = statement;
            Scope = scope;
        }

        public override BoundKind Kind => BoundKind.BoundScript;
        public override IEnumerable<BoundNode> GetNodeAtPosition(int characterPosition)
        {
            foreach (var boundNode in Statement.GetNodeAtPosition(characterPosition)) yield return boundNode;
        }

        public BoundBlockStatement Statement { get; }
        public BoundScope Scope { get; }
    }
}