using Upsilon.BaseTypes;
using Upsilon.BoundTypes;

namespace Upsilon.Binder.VariableSymbols
{
    public class FunctionParameterSymbol : VariableSymbol
    {
        public BoundTypeDefinition BoundTypeDefinition { get; }

        public FunctionParameterSymbol(string name, Type type) : base(name, type, true)
        {
            _type = type;
        }

        public FunctionParameterSymbol(string name, BoundTypeDefinition type) : base(name, type.ScriptType, true)
        {
            BoundTypeDefinition = type;
        }

        private Type _type;
        public override Type Type
        {
            get => BoundTypeDefinition?.ScriptType ?? _type;
            set => _type = Type;
        }
    }
}