using System;

namespace Upsilon.StandardLibraries
{
    [AttributeUsage(AttributeTargets.Method, AllowMultiple = true, Inherited = true)]
    public class StandardLibraryScriptFunctionAttribute : Attribute
    {
        public StandardLibraryScriptFunctionAttribute(string name, string comment = null,
            bool passScriptReference = false, bool passScopeReference = false)
        {
            Name = name;
            Comment = comment;
            PassScriptReference = passScriptReference;
            PassScopeReference = passScopeReference;
        }

        public string Name { get; }
        public string Comment { get; }
        public bool PassScriptReference { get; }
        public bool PassScopeReference { get; }
    }
}